// Einspeisewechselrichter

#define PWM_CT2    3 //OC2B
void ct2_init()
{
  pinMode(PWM_CT2, OUTPUT);
  TCCR2A = (1 << COM2B1) | (1 << WGM20); 
  TCCR2B = (1 << CS22) | (1 << CS21) | (1 << CS20) | (1 << WGM22) ;   
  OCR2A = 156;
  OCR2B = 7;                               // pwm value  
}

#define dcdcanpin 7

// OVLO mit Auszeit
#define drainpin 6
#define dcdcauspin 4
unsigned long drainist;
unsigned long drainstart;
unsigned long drainvz = 10000; 
bool drain;
bool ovlodrain;
bool dcdcaus;

// UVLO Batterie mit Hysterese
#define battpin A0
unsigned long battist;
unsigned long battstart;
int battwerthoch = 464; // 1023*11V*39K:(150K + 39K):5V
int battwerttief = 378; // 1023*9V0*39K:(150K + 39K):5V
int battwertovlo = 676;  // 1023*16V*39K:(150K + 39K):5V
int battwert;
bool batt;
bool uvlobatt;

// UVLO Netz mit Hysterese
unsigned long netzist;
unsigned long netzstart;
int netzwerthoch = 1020;
int netzwerttief = 920;
int netzwert;
bool netz;
bool uvlonetz;
bool lo;

// Nulldurchgang
#define analogscheitelpin A1
#define digitalscheitelpin 2
bool nulldurchgang;
bool nulldurchgangvorher;
bool nulldurchgangflanke;

// Scheitelpunkt
bool scheitelpunkt_flag;
unsigned long acttime;

// dc-dc-Converter Start
bool dcdcan;
unsigned long startzeit;

// Testpins
#define testxpin 10
#define testypin 11
#define testzpin 12
#define ledpin   13

void setup() 
{
  ct2_init();
  
  pinMode(digitalscheitelpin,INPUT_PULLUP);
  pinMode(dcdcauspin,OUTPUT);
  pinMode(dcdcanpin,OUTPUT);
  pinMode(ledpin,OUTPUT);
  pinMode(testxpin,OUTPUT);
  pinMode(testypin,OUTPUT);
  pinMode(testzpin,OUTPUT);
  digitalWrite(dcdcauspin,HIGH);
  digitalWrite(dcdcanpin,LOW);
  ovlodrain = LOW;
  // Prüfung der Batteriespannung
  battwert = battwerthoch;
  batt = (analogRead(battpin) > battwert);
  if(!batt)
  {
     uvlobatt = HIGH;
     battwert = battwerthoch;
  }
  else
  {
    uvlobatt = LOW;
    battwert = battwerttief;
  }      
  delay(2000);
}

void amscheitelpunktlesen() 
{
  // OVLO Drainspannung  
  drain = digitalRead(drainpin);
    if(!drain)
  {
    drainist = millis();
    if(drainist - drainstart > drainvz)
    {
      ovlodrain = LOW;
    }
  }
  else
  {
    drainstart = millis();
    ovlodrain = HIGH;
  }

  // UVLO Batteriespannung (bei Unterspannung HIGH)
  batt = (analogRead(battpin) > battwert);
    if(!batt)
  {
     uvlobatt = HIGH;
     battwert = battwerthoch;
  }
  else
  {
    uvlobatt = LOW;
    battwert = battwerttief;
  }  
  
  // UVLO Netzspannung (bei Unterspannung HIGH)
  netz = (analogRead(analogscheitelpin) > netzwert);
    if(!netz)
  {
    netzist = millis();
    if(netzist - netzstart > 11)
    {
      uvlonetz = HIGH;
      netzwert = netzwerthoch;
    }
  }
  else
  {
    netzstart = millis();
    uvlonetz = LOW;
    netzwert = netzwerttief;
  }
}

void loop() 
{
// Nulldurchgang Flankenerkennung
  nulldurchgang = digitalRead(digitalscheitelpin);
    
// Flanke
  nulldurchgangflanke = ((nulldurchgang != nulldurchgangvorher) && (nulldurchgangvorher == LOW));
  nulldurchgangvorher = nulldurchgang;

  if(nulldurchgangflanke == HIGH)
  {
    startzeit = micros();
    scheitelpunkt_flag = false;
  }

  if (!scheitelpunkt_flag)
  {
    acttime = micros() - startzeit;
    if (acttime >= 4800)  // analogread 400us, advance 200us
    {
      scheitelpunkt_flag = true;
      amscheitelpunktlesen();
    }
  }
  
  lo = uvlonetz || ovlodrain || uvlobatt;
  lo = false;

  //DC-DC-Converter Start    
  acttime = micros() - startzeit;
  dcdcan = (acttime >= 1000) && (acttime <= 9000) && !lo;
  dcdcaus = !dcdcan || lo;
  
  digitalWrite(dcdcauspin,dcdcaus); 
  digitalWrite(dcdcanpin, dcdcan);

  digitalWrite(testxpin, scheitelpunkt_flag); // D10
  digitalWrite(testypin,nulldurchgangflanke); // D11
  digitalWrite(ledpin, lo); 
}  
